package me.unurled.sacredrealms.sr.components.attributes;

import org.bukkit.NamespacedKey;
import org.bukkit.persistence.PersistentDataType;

public enum Attribute {
  HEALTH(
      "HEALTH",
      "Health",
      100,
      100000,
      0,
      PersistentDataType.DOUBLE,
      new NamespacedKey("sr", "HEALTH")),
  STRENGTH(
      "STRENGTH",
      "Strength",
      10,
      10000,
      0,
      PersistentDataType.DOUBLE,
      new NamespacedKey("sr", "STRENGTH")),
  DEFENSE(
      "DEFENSE",
      "Defense",
      10,
      10000,
      0,
      PersistentDataType.DOUBLE,
      new NamespacedKey("sr", "DEFENSE")),
  AGILITY(
      "AGILITY",
      "Agility",
      100,
      10000,
      100,
      PersistentDataType.DOUBLE,
      new NamespacedKey("sr", "AGILITY")),
  LUCK(
      "LUCK",
      "Luck",
      100,
      99999,
      -99999,
      PersistentDataType.INTEGER,
      new NamespacedKey("sr", "LUCK")),
  MANA("MANA", "Mana", 100, 10000, 0, PersistentDataType.DOUBLE, new NamespacedKey("sr", "MANA")),
  CHARISMA(
      "CHARISMA",
      "Charisma",
      0,
      10000,
      -10000,
      PersistentDataType.INTEGER,
      new NamespacedKey("sr", "CHARISMA")),
  ;

  private final String name;
  private final String ID;
  private final int defaultValue;
  private final int maxValue;
  private final int minValue;
  private final PersistentDataType type;
  private final NamespacedKey key;

  Attribute(
      String ID,
      String name,
      int defaultValue,
      int maxValue,
      int minValue,
      PersistentDataType type,
      NamespacedKey key) {
    this.ID = ID;
    this.name = name;
    this.defaultValue = defaultValue;
    this.maxValue = maxValue;
    this.minValue = minValue;
    this.type = type;
    this.key = key;
  }

  public String getName() {
    return name;
  }

  public String getID() {
    return ID;
  }

  public int getDefaultValue() {
    return defaultValue;
  }

  public int getMaxValue() {
    return maxValue;
  }

  public int getMinValue() {
    return minValue;
  }

  public PersistentDataType getType() {
    return type;
  }

  public NamespacedKey getKey() {
    return key;
  }
}
