package me.unurled.sacredrealms.sr.data;

import com.google.gson.Gson;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public interface DataHandler {

  /**
   * Get a value from the data source
   *
   * @param key The key to get the value from
   * @return The value of the key
   */
  String get(@NotNull String key);

  /**
   * Get a value from the data source
   *
   * @param key The key to get the value from
   * @return The value of the key
   */
  Object getGson(@NotNull String key);

  /**
   * Set a value in the data source
   *
   * @param key The key to set the value to
   * @param value The value to set
   */
  void set(@NotNull String key, @Nullable String value);

  /**
   * Set a value in the data source
   *
   * @param key The key to set the value to
   * @param value The value to set
   */
  void set(@NotNull String key, Gson value);

  /**
   * Append a value to the data source
   *
   * @param key The key to append the value to
   * @param path The path to append the value to
   * @param json The json to append
   */
  void jsonAppend(@NotNull String key, @NotNull String path, @NotNull Object... json);

  /**
   * Remove a value from the data source
   *
   * @param key The key to remove the value from
   */
  void remove(@NotNull String key);
}
