package me.unurled.sacredrealms.sr.data;

import static me.unurled.sacredrealms.sr.utils.Logger.error;

import java.io.File;
import java.io.IOException;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.sacredrealms.sr.data.DataHandler;
import me.unurled.sacredrealms.sr.data.Redis;
import me.unurled.sacredrealms.sr.managers.Manager;
import org.bukkit.configuration.file.FileConfiguration;

/** The data and config manager */
public class DataManager extends Manager {

  private FileConfiguration config;

  private DataHandler dh;

  /** Load the manager */
  @Override
  public void load() {
    super.load();
    dh = new Redis();
  }

  /** Save the data */
  @Override
  public void saveData() {
    try {
      if (config != null) config.save(new File(SR.getInstance().getDataFolder(), "config.yml"));
    } catch (IOException e) {
      error("Failed to save config.yml");
    }
  }

  /** Load the data */
  @Override
  public void loadData() {
    SR.getInstance().saveConfig();
    SR.getInstance().reloadConfig();
    config = SR.getInstance().getConfig();
  }

  /**
   * Get the config
   *
   * @return The config
   */
  public FileConfiguration getConfig() {
    return config;
  }

  /**
   * Get the data handler
   *
   * @return The data handler
   */
  public DataHandler getDataHandler() {
    return dh;
  }
}
