package me.unurled.sacredrealms.sr.managers;

import java.util.ArrayList;
import java.util.List;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.sacredrealms.sr.components.combat.CombatManager;
import me.unurled.sacredrealms.sr.components.item.ItemManager;
import me.unurled.sacredrealms.sr.components.player.PlayerManager;
import me.unurled.sacredrealms.sr.data.DataManager;
import org.bukkit.Bukkit;
import org.jetbrains.annotations.Nullable;

public class Managers {

  private final List<Manager> managers;

  public Managers() {
    managers = new ArrayList<>();
    // register managers here (like a new instance of them)

    Bukkit.getScheduler()
        .runTaskLater(
            SR.getInstance(),
            () -> {
              new DataManager();
              new PlayerManager();
              new ItemManager();
              new CombatManager();
            },
            10L);
  }

  public void addManager(Manager manager) {
    managers.add(manager);
  }

  public void unload() {
    for (Manager manager : managers) {
      manager.unload();
    }
  }

  @Nullable
  public Manager getManager(Class<? extends Manager> clazz) {
    for (Manager manager : managers) {
      if (manager.getClass().equals(clazz)) {
        return manager;
      }
    }
    return null;
  }
}
